#ifndef _FILE_READER_H_
#define _FILE_READER_H_

#include "18fUtil.h"

/* Return values */
#define NULL_MEM_PTR 		  -1
#define NO_ENTRY_FOUND        NULL_MEM_PTR

/* TOC entry type values */
#define SERVO_CONFIG_TABLE		0x30
#define SENSOR_CLBRTN_TABLE		0x31
#define STANCE_CONTROLLER		0x32
#define ATTACH_GESTURE			0x36

/* TOC location */
#define TOC_START             FLASH_DATA

/* This returns the location of the first entry of the specified type.  If
 * there is no entry in the ToC, it will return NO_ENTRY_FOUND */
unsigned int FR_FindEntry(unsigned char EntryType);
void FR_ReadGestureData(unsigned int * byte_inx, unsigned char * cmd, unsigned int * data);


#endif
