#include "18fXX20_conf.h"
//#include <p18cxxx.h>
#include "serial.h"
#include "servo.h"
#include "18fUtil.h"
//#include "MatrixMath.h"
#include "StanceController.h"
#include "Display.h"
#include "18fSensors.h"
//#include "ServoConfig.h"
#include "ControllerMath.h"
#include "PhysicalConfig.h"
#include "interrupts.h"
#include "keys.h"
#include "CtrlCloseLoop.h"
#include "CtrlOpenLoop.h"

#pragma code

#define PAUSE_MODE 0
#define CLOSED_LOOP_MODE 1
#define OPEN_LOOP_MODE 2

void main_test(void)
{
	KeyEvent_t key_event;
	Number_t forward;
	Number_t backward;
	
	INRPT_InitTimer();
	InitKeys();
	DSP_InitDisplay();
	
	DSP_Hello();
	
	INTCONbits.PEIE = 1;
	INTCONbits.GIE = 1;
	
	
	INRPT_EnableTimer();
	DSP_SetHeartbeat(5);
	
	
	while(1)
	{
		if (HasTimerTriggered())
		{			
			key_event = CheckKeyEvent();
			
			switch(key_event)
			{
				case B0_PRESS:
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					break;
				case B1_PRESS:
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					break;
				case R0_PRESS:
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					break;
				case R1_PRESS:
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					break;
				case R2_PRESS:
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					break;
				case R3_PRESS:
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					break;
				case B0_HOLD:
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					break;
				case B1_HOLD:
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					break;
				case R0_HOLD:
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					break;
				case R1_HOLD:
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					break;
				case R2_HOLD:
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					break;
				case R3_HOLD:
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					break;
				case B0_B1_HOLD:
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					break;
				case R0_R1_HOLD:
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					DSP_SetGreen(1);
					Milliseconds(125);
					DSP_SetGreen(0);
					Milliseconds(125);
					break;
				case R2_R3_HOLD:
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					DSP_SetRed(1);
					Milliseconds(125);
					DSP_SetRed(0);
					Milliseconds(125);
					break;
				default:
					break;
			}
			SRV_UpdateServoValues();
		}
	}
}

void main(void)
{	
	static unsigned char mode = PAUSE_MODE;

	static unsigned char leg = 0;
	static unsigned char servo_report = 0;
	static unsigned char force_report = 0;
	
	INRPT_InitTimer();
	InitKeys();
	SNS_InitSensors();
	SRL_InitializeSerialPort();
	SRV_InitializeServos();
	DSP_InitDisplay();
	
	DSP_Hello();
	
	INTCONbits.PEIE = 1;
	INTCONbits.GIE = 1;
	
	SNS_PollSensors();
	SNS_ZeroSensors();
	
	SRV_MoveToHome();
	INRPT_EnableTimer();
	SRV_EnableServos();
	DSP_SetHeartbeat(5);
	
	while(1)
	{
		SRL_HandleData();

		if (HasTimerTriggered())
		{
			SNS_PollSensors();

			SRL_SendForces();

			switch (mode)
			{
				case CLOSED_LOOP_MODE:
					Ctrl_CloseLoop();
				break;
				case OPEN_LOOP_MODE:
					Ctrl_OpenLoop();
				break;
				case PAUSE_MODE:
					SRV_SetAllAbs(SRV_GetOffset());
					SRV_UpdateServoValues();
				break;
			}	

			//Produce heartbeat
			DSP_Heartbeat();
			
			//Produce any error flashes
			DSP_DisplayError();
			
			switch(CheckKeyEvent())
			{
				case B0_PRESS:
				case R0_PRESS:
					switch (mode)
					{
						case CLOSED_LOOP_MODE:
							CTRL_CL_EnableCtrl();
						break;
						case OPEN_LOOP_MODE:
							CTRL_OL_EnableCtrl();
						break;
						case PAUSE_MODE:
							SRV_ToggleServos();
						break;
					}
				break;
				case B1_PRESS:
				case R1_PRESS:
					switch (mode)
					{
						case CLOSED_LOOP_MODE:
							CTRL_CL_DisableCtrl();
						break;
						case OPEN_LOOP_MODE:
							CTRL_OL_DisableCtrl();
						break;
						case PAUSE_MODE:
							SNS_ZeroSensors();
						break;
					}
				break;
				case B0_HOLD:
				case R0_HOLD:
					SRV_EnableServos();

					CTRL_OL_DisableCtrl();
					CTRL_CL_DisableCtrl();

					CTRL_CL_ResetCtrl();
					mode = CLOSED_LOOP_MODE;
					DSP_SetHeartbeat(5);
					break;
				case B1_HOLD:
				case R1_HOLD:
					SRV_EnableServos();

					CTRL_OL_DisableCtrl();
					CTRL_CL_DisableCtrl();

					CTRL_OL_ResetCtrl();
					mode = OPEN_LOOP_MODE;
					DSP_SetHeartbeat(4);
					break;
				case B0_B1_HOLD:
				case R0_R1_HOLD:
					CTRL_OL_DisableCtrl();
					CTRL_CL_DisableCtrl();

					mode = PAUSE_MODE;
					DSP_SetHeartbeat(6);
					SRV_MoveToHome();
				break;
			}
		}
	}
}
