/*****************************************************************************
 *                                 serial.h                                  *
 *****************************************************************************
Author: Salomon Trujillo
*/

//Duplication protection
#ifndef _SERIAL_H_
#define _SERIAL_H_

	//Initializes the serial port. This will also produce the power-up message.
	void SRL_InitializeSerialPort(void);

	//This function acts as the link between the software FIFOs
	//and the serial port hardware. This should be called by
	//the interrupt service routine
	void SRL_HandleSerialPort(void);

	//This function handles all the data in the software FIFOs
	//It should be called often, but it is not a high priority
	//function. (Note: it should be called faster than the 
	//20ms control loop.)
	void SRL_HandleData(void);

	//This transmits a byte. If the byte matches a command byte
	//it will escape it. (See the TWiki for details.)
	void SRL_SendData(unsigned char data);
	
	//This will send raw bytes without escaping them. This is
	//good for sending commands.
	void SRL_SendCmd(unsigned char data);

	void SRL_SendServos(void);
	//void SRL_SendRawServos(void);
	void SRL_SendForces(void);
	void SRL_SendRawSensors(void);

#endif
