#ifndef _SERVO_H_
#define _SERVO_H_

	#include "ServoConfig.h"
	#include "PhysicalConfig.h"
	
	/* My thought: Lets have everything outside of the servo module work with
	 * Number_t servo positions, all relative to home.
	 * => 6 sets and 3 gets
	 * 2(rel and abs) * 3(single, group, all) sets
	 * 1(abs) * 3(single, group, all) gets
	 */
	

	//Public function prototypes
	void SRV_InitializeServos(void);
	void SRV_MoveToHome(void);	//<=>SRV_SetAllAbs(*all zeros*)
	void SRV_EnableServos(void);
	void SRV_DisableServos(void);
	void SRV_ToggleServos(void);
	void SRV_GenerateServoPWM(void);
	void SRV_UpdateServoValues(void);
	void SRV_SetSingleAbs(Leg_t leg, ServoType_t type, Number_t position);
	void SRV_SetSingleRel(Leg_t leg, ServoType_t type, Number_t position);
	void SRV_SetGroupAbs(ServoType_t type, ServoGroupNumber_t *positions);
	void SRV_SetGroupRel(ServoType_t type, ServoGroupNumber_t *positions);
	void SRV_SetAllAbs(ServoNumber_t *positions);
	void SRV_SetAllRel(ServoNumber_t *positions);
	Number_t SRV_GetSingleTarget(Leg_t leg, ServoType_t type);
	void SRV_GetGroupTargets(ServoType_t type, ServoGroupNumber_t *dest);
	void SRV_GetAllTargets(ServoNumber_t *dest);
	void SRV_SetOffset(Leg_t leg, ServoType_t type, Number_t offset);
	ServoNumber_t * SRV_GetOffset(void);
	
#endif
